<?php
// (c)2007 Matteo Lucarelli
// 3editor configuration file

// general *********************************************************************

// Title shown in every page (css styled)
define ("CMS_TITLE", "Amministrazione dei contenuti");

// XML encoding ("UTF8", "ISO-8859-1", ecc.)
define ("XML_ENCODING", "ISO-8859-1");

// max name dimension for uploaded files 
define ("MAX_FILENAME_SIZE", "16");

// set to 1 if you want to delete xml when section are empty
// (this can facilitate backups but can generate errors with external parsers)
define ("DELETE_WHEN_EMPTY", "1");

// set to 1 to use the beautiful fading help
define ("USE_FADE_HELP", "1");

// set to 1 to use the rich text editor in long descriptions
define ("USE_RICH_TEXT", "1");

// set to 1 to use the javascript tab for multilanguage fields
define ("USE_JS_TABS", "1");


// server addresses ***********************************************************

// absolute path on server - with SLASH/
define ("ABS_PATH","/var/www/3editor0.68/");

// address as viewed from the internet
define ("SITE_ADDR","http://127.0.0.1/3editor0.68/");


// languages ******************************************************************

// main language - must corespond to a file in phplib/lang
$lang = "it";

// to set multiple languages in text fields
// don't put spaces in labels - for monolanguage set one empty string: ("")
$langs = array ( "it", "en" );
$langdescr = array ( "Italiano", "Inglese" );


// thumbs *********************************************************************

// max dim of thumbnails in pixel
define ("THUMB_MAXW", "100");
define ("THUMB_MAXH", "100");

// thumb generation mode
// R : resize with max dim THUMB_MAXW x THUMB_MAXH
// C : cut around the center with dim THUMB_MAXW x THUMB_MAXH
define ("THUMB_MODE", "R");

// tool used to generate thumb: I=imagemagik | L=libgd (verify avalability on server)
define ("THUMB_GEN", "I");

// convert/imagemagik command path ( "" if standard )
define ("IMGMGK_PATH", "");


// tree editing options *******************************************************

// directory where put tree xml and sections folders
// the path is relative to index.php - with SLASH/
// NOTE: base path must exists
define ("DATA_DIR_TREE","data/gallery/");

// filename of tree xml  - created inside DATA_DIR_TREE
define ("XML_TREE","tree.xml");

// limit nested level in tree structure
define ("LIMIT_NEST", "2");

// avoid image.list editing under nested-level
define ("LIMIT_CONTENT_IMAGES", "0");

// avoid document-list editing under nested-level
define ("LIMIT_CONTENT_DOCS", "0");

// avoid text editing under nested-level
define ("LIMIT_CONTENT_TEXT", "0");

// avoid editing of tree under nested-level
define ("LOCK_UNTIL_LEVEL", "0");

// don't show operation to move subsection
define ("DONT_MOVE_TREE", "1");


// section editing options ****************************************************

// toggle use of global section description (text)
define ("USE_SECTION_DESCR", "1");

// toggle use of section images list
define ("USE_SECTION_IMAGES", "1");

// toggle use of section documents list
define ("USE_SECTION_DOCS", "1");

// toggle use of one long description for every image
define ("USE_IMG_DESCR", "1");

// toggle use only text in images section (MUST BE FIX!)
define ("USE_IMG_IMAGE", "0");

// toggle use of one long description for every document
define ("USE_DOC_DESCR", "1");

// filename of image-list xml - created inside section folder
define ("XML_SECT_PHOTO","sectionphotos.xml");

// filename of documents-list xml - created inside section folder
define ("XML_SECT_DOCS","sectiondocs.xml");

// filename of sections' descriptions xml - created inside section folder
define ("XML_SECT_TEXT","sectiontext.xml");

// toggle use of "cover image" flag in image lists
// the user can mark an image as "cover image" in every section
define ("USE_COVER", "1");

// toggle the creation of one more custom-size thumb for cover-marked image
define ("USE_COVER_THUMB", "1");

// dim of cover thumbnail in pixel
define ("COVER_THUMB_MAXW", "200");
define ("COVER_THUMB_MAXH", "200");

// images fields - every line is a user field for every image in image-list
// 'descr' is the name showed, field is used in xml (avoid special chars)
// if 'required'==1 CMS will control that user insert a unique value 
// if 'multilanguage'==0 one label for every language will be configured
$imgfield = array (
	array ( "descr" => "Titolo" , "field" => "title" , "required" => 1 , "multilanguage" => 0 ),
	array ( "descr" => "Titolo" , "field" => "label" , "required" => 0 , "multilanguage" => 1 )
	);

// documents fields - same as images fields but for document list
$docfield = array (
//	array ( "descr" => "Titolo-univ" , "field" => "title1" , "required" => 1 , "multilanguage" => 0 ),
	array ( "descr" => "Titolo" , "field" => "title" , "required" => 1 , "multilanguage" => 1 )
	);


// optional sections **********************************************************

// directory where put optional pages folders
// the path is relative to index.htm - with SLASH/
// NOTE: base path must exists
define ("DATA_DIR_OPT","data/optsections/");

// every optional sections creates an xml and a folder named as the 
// optsection (lowercased) - don't use spaces or specials chars
$optsection= array ("Links", "News", "Downloads");

// Title of the optsection shown to the user (one array for every configured language)
$optsection_title = array (
	"it" => array ("Collegamenti"   , "Notizie & Novita'", "Downloads"),
	"en" => array ("Links & Network", "News"             , "Downloads")
	);

// text fields in optional sections - every line is a field
// 'descr' is the name showed, field is used in xml (avoid special chars)
// if 'required'==1 CMS will control that user inser a unique value 
// if 'multilanguage'==0 one label for every language will be configured
$optfield['Links'] = array ( 
	array ( "descr" => "Titolo" , "field" => "title" , "required" => 1 , "multilanguage" => 1 ),
	array ( "descr" => "URL"    , "field" => "link"  , "required" => 1 , "multilanguage" => 0 )
	);
$optfield['News'] = array ( 
	array ( "descr" => "Data"   , "field" => "date"  , "required" => 1 , "multilanguage" => 0 ),
	array ( "descr" => "Titolo" , "field" => "title" , "required" => 0 , "multilanguage" => 1 ),
	);	
$optfield['Downloads'] = array ( 
	array ( "descr" => "Nome" , "field" => "name" , "required" => 1 , "multilanguage" => 1 ),
	);

// toggle the use of images in optional section
$optimage = array ( "Links" => 0 , "News" => 1 , "Downloads" => 0);

// toggle the use of updloadable files in optional section
$optfile = array ( "Links" => 0 , "News" => 1 , "Downloads" => 1);


// fixed path files editing section ********************************************

// directory where put fixed files 
// neither the number nor the name is modificable by user)

// the path is relative to index.htm - with SLASH/
// NOTE: base path must exists
define ("DATA_DIR_FIX","data/files/");

// filename of fixed file xml - relative to DATA_DIR_FIX
define ("XML_FXFILES","file.xml");

// section label ("0" means don't use) 
define ("FX_FILES_SECTION", "Sfondi e Musiche");

// labels and paths (relative to DATA_DIR_FIX) of fixed files
// existings files are overwritten - don't forget permissions
$ffs[0]['label']="Immagine di sfondo (jpg)";
$ffs[0]['path']="background.jpg";
$ffs[1]['label']="Musica 1 (mp3)";
$ffs[1]['path']="music1.mp3";
$ffs[2]['label']="Musica 2 (mp3)";
$ffs[2]['path']="music2.mp3";

?>
