<?php
// (c)2006 Matteo Lucarelli
// XML load/store functions

require_once('config.php');
require_once('utils.php');
require_once("lang/".$lang.".php");

complete_multilanguage_fields();

// tree management functions //////////////////////////////////////////////////

function cb_open_tree($parser, $tag, $attrs) {

	global $level,$tree,$langs;
	
	if ($tag=="NODE"){
		$attrs["LEVEL"]=$level++;
		$tree[]=$attrs;
		
		//for($i=0 ; $i<count($tree); $i++)
		//	for ($j=0;$j<count($langs);$j++)
		//		$tree[$i]['LABEL'.strtoupper($langs[$j])]=clean_label($tree[$i]['LABEL'.strtoupper($langs[$j])]);
	}
} 

function cb_close_tree($parser, $tag) { 

	global $level;
	if ($tag=="NODE") $level--;
}

function tree_load(){

	global $tree,$level,$section,$sectiondocs;
	
	$tree=array();
	$level=0;

	$parser = xml_parser_create(XML_ENCODING);
	xml_parser_set_option($parser,XML_OPTION_CASE_FOLDING,1);
	xml_parser_set_option($parser,XML_OPTION_SKIP_WHITE,1);
	xml_set_element_handler ( $parser, "cb_open_tree", "cb_close_tree" ); 
	
	if ($fp = @fopen(DATA_DIR_TREE.XML_TREE,'r')){
		while ($data = fgets($fp, 8192))
			xml_parse($parser, $data, feof($fp)); 
		@fclose($fp);
	}
	else{
		xml_parser_free($parser);
		return (touch_tree_folder());
	}
	xml_parser_free($parser);
	
	// load section counts
	for ($i=0; $i<count($tree); $i++){
	
		if (section_load($tree[$i]['LINK'])) $tree[$i]['IMAGECOUNT']=count($section);
		else $tree[$i]['IMAGECOUNT']=0;
		
		if (sectiondocs_load($tree[$i]['LINK'])) $tree[$i]['DOCSCOUNT']=count($sectiondocs);
		else $tree[$i]['DOCSCOUNT']=0;
	}
	unset($section);
	unset($sectiondocs);	
	
	return TRUE;
}

// delete directories not in tree nodes
function delete_old_dir($basedir){

	global $tree,$optsection;
	$ret=true;

	if ($dh = @opendir($basedir)) {
		while (($file = @readdir($dh)) !== false) {
			if ((@is_dir($basedir.$file))&&($file!=".")&&($file!="..")){
				$ret=$ret&&delete_old_dir($basedir.$file."/");
				$todel=TRUE;
				
				if ($tree) foreach ($tree as $item) 
					if ($basedir.$file==DATA_DIR_TREE.$item['LINK']) $todel=FALSE;
				
				if ($todel){
					if ($dh2 = @opendir($basedir.$file)){
						while (($file2 = readdir($dh2)) !== false)
							if (!is_dir($basedir.$file."/".$file2))
								if (!@unlink($basedir.$file."/".$file2)) $ret=false;
						closedir($dh2);
					}else $ret=false;
					if (!@rmdir($basedir.$file)) $ret=false;
				}
			}
		}
		closedir($dh);
	}
	return $ret;
}

function tree_save($form_id,$treecount){

	global $tree,$err_str,$langs,$links;
	
	if ($treecount!=count($tree)){
		$err_str = STR_ERR_SAVE;
		return;
	}
	
	// verify lock file
	switch (verify_lock(DATA_DIR_TREE,$form_id)){
		case -1: $err_str= STR_ERR_SAVE;
			 return;
		case 0:  break;
		case 1:  return;
		case 2:  $err_str= STR_ERR_LOCK;
		         return;
	}
	
	$xml = "<?xml version='1.0' encoding='".XML_ENCODING."'?>\n";
	$xml.= "<tree>\n";
	
	$cl=-1;
	
	for ($i=0;$i<count($tree);$i++){
			
		// close node-field and store level
		for (;$tree[$i]['LEVEL']<=$cl;$cl--)  $xml.="</node>\n";
		$cl=$tree[$i]['LEVEL'];
		
		// give a value to new link field and rename modified folders
		if ($tree[$i]['LINK']!='') {
			if ($tree[$i]['LEVEL']>0) $oldpath=substr($links[$i],0,strrpos($links[$i],"/")).strrchr($tree[$i]['LINK'],"/");
			else $oldpath=$tree[$i]['LINK'];
			if (($oldpath!=$links[$i])&&(file_exists(DATA_DIR_TREE.$oldpath))) 
				@rename(DATA_DIR_TREE.$oldpath,DATA_DIR_TREE.$links[$i]);
		}
		$tree[$i]['LINK']=$links[$i];
		
		// create new folder
		$cpath=DATA_DIR_TREE.$tree[$i]['LINK'];
		if (!file_exists($cpath)) 
			if (!@mkdir($cpath)) $err_str= STR_ERR_SAVE ;
		
		// touch new xml for new section
		if (!file_exists($cpath.'/'.XML_SECT_PHOTO)){
			if ($fp=@fopen($cpath.'/'.XML_SECT_PHOTO,'w')){
				@fwrite($fp,"<?xml version='1.0' encoding='".XML_ENCODING."'?>\n");
				@fclose($fp);
			}else $err_str = STR_ERR_SAVE;
		}
		if (!file_exists($cpath.'/'.XML_SECT_DOCS)){
			if ($fp=@fopen($cpath.'/'.XML_SECT_DOCS,'w')){
				@fwrite($fp,"<?xml version='1.0' encoding='".XML_ENCODING."'?>\n");
				@fclose($fp);
			}else $err_str = STR_ERR_SAVE;
		}
		if (!file_exists($cpath.'/'.XML_SECT_TEXT)){
			if ($fp=@fopen($cpath.'/'.XML_SECT_TEXT,'w')){
				@fwrite($fp,"<?xml version='1.0' encoding='".XML_ENCODING."'?>\n");
				@fclose($fp);
			}else $err_str = STR_ERR_SAVE;
		}
		
		$xml.= "<node link='".$tree[$i]['LINK']."'";
		for ($j=0;$j<count($langs);$j++)
			$xml.= " label".strtolower($langs[$j])."='".$tree[$i]['LABEL'.strtoupper($langs[$j])]."'";
		$xml.= ">\n";
	}
	for (;0<=$cl;$cl--)  $xml.="</node>\n";
	$xml.= "</tree>\n";
	
	if ($fp=@fopen(DATA_DIR_TREE.XML_TREE, 'w')){
		@fwrite ($fp,$xml);
		@fclose($fp);
	}else $err_str = STR_ERR_SAVE ;
	
	if (!delete_old_dir(DATA_DIR_TREE)) $err_str = STR_ERR_SAVE;
	
	if ((DELETE_WHEN_EMPTY==1)&&(count($tree)==0)) @unlink(DATA_DIR_TREE.XML_TREE);
	
	unlock(DATA_DIR_TREE);
}

function delete_old_files($path)
{
	global $section,$sectiondocs;
	
	section_load($path);
	sectiondocs_load($path);

	// delete file not in list
	if ($dh = opendir(DATA_DIR_TREE.$path)) {
		while (($file = readdir($dh)) !== false) {
			if ((!is_dir(DATA_DIR_TREE.$path."/".$file))&&($file!=XML_SECT_PHOTO)&&($file!=XML_SECT_DOCS)&&($file!=XML_SECT_TEXT)){
				$todel=TRUE;
				if ((USE_COVER_THUMB)&&($file=="index.jpg")) $todel=FALSE;
				foreach ($section as $item) 
					if (($item['IMG']==$file)||("thumb.".$item['IMG']==$file)){
						$todel=FALSE;
						break;
					}
				foreach ($sectiondocs as $item) 
					if ($item['FILE']==$file){
						$todel=FALSE;
						break;
					}						
				if ($todel){
					@unlink(DATA_DIR_TREE.$path."/".$file);
					@unlink(DATA_DIR_TREE.$path."/thumb.".$file);
				}
			}
		}
		closedir($dh);
	}
}

// image lists management functions ////////////////////////////////////////////

function cb_close_section($parser, $tag) {

	global $sectionindex,$langindex;
	
	if ($tag=="ITEM"){
		$sectionindex=-1;
	}else if ($tag=="DESCR"){
		$langindex = -1;
	}
}

function cb_open_section($parser, $tag, $attrs) {

	global $section,$cover,$showcover,$langs,$imgfield,$sectionindex,$langindex;
	
	if ($tag=="ITEM"){
		
		$sectionindex=count($section);
		
		$section[$sectionindex]['IMG']=$attrs['IMG'];
		
		for ($j=0;$j<count($imgfield);$j++){
			$section[$sectionindex][$j]=clean_label($attrs[strtoupper($imgfield[$j]['field'])]);
		}
		
	}else if ($tag=="DESCR"){
		
		$langindex=-1;
		for ($j=0;$j<count($langs);$j++){
			if (strtoupper($langs[$j])==strtoupper($attrs['LANG'])) $langindex=$j;
		}
	
	}else if ($tag=="SECTION"){
		$cover=$attrs['COVER'];
		$showcover=$attrs['SHOWCOVER'];
	}
}

function cb_data_section($parser, $data) {

	global $section,$sectionindex,$langindex,$langs;
	
	if (($langindex>=0)&&($sectionindex>=0))
		$section[$sectionindex]['TEXT'.strtoupper($langs[$langindex])] .= $data;
}

function section_load($path){

	global $section,$sectionindex,$langindex;
	
	$section=array();
	$loaded=TRUE;
	$sectionindex=-1;
	$langindex=-1;
	
	$parser = xml_parser_create(XML_ENCODING);
	xml_parser_set_option($parser,XML_OPTION_CASE_FOLDING,1);
	xml_parser_set_option($parser,XML_OPTION_SKIP_WHITE,1);
	xml_set_element_handler ( $parser, "cb_open_section", "cb_close_section" );
	xml_set_character_data_handler($parser, "cb_data_section");
	
	if ($fp = @fopen(DATA_DIR_TREE.$path.'/'.XML_SECT_PHOTO,'r')){
		while ($data = @fgets($fp, 8192))
			xml_parse($parser, $data, feof($fp));
		@fclose($fp);
	}
	else $loaded=FALSE;
	xml_parser_free($parser);

	return $loaded;
}

function section_save($path,$files,$form_id,$sectioncount){

	global $section,$descr,$cover,$showcover,$err_str,$langs,$imgfield;
	
	if ($sectioncount!=count($section)){
		$err_str=STR_ERR_SAVE;
		return;
	}
	
	// verify lock file
	switch (verify_lock(DATA_DIR_TREE,$form_id)){
		case -1: $err_str= STR_ERR_SAVE;
			 return;
		case 0:  break;
		case 1:  return;
		case 2:  $err_str= STR_ERR_LOCK;
		         return;
	}
	
	$xml = "<?xml version='1.0' encoding='".XML_ENCODING."'?>\n";
	
	$xml.= "<section cover='".$cover."' ";
	$xml.= "showcover='".$showcover."'>\n";
	
	for ($i=0;$i<count($section);$i++){
		
		// load new files
		if ($files["userfile$i"]['name']!=''){
		
			if ($files["userfile$i"]['error']!=0){
				$err_str = STR_ERR_SAVE . " (err: ".$files["userfile$i"]['error'].")";
				$section[$i]['ERRCH']="*";
			}
			
			$destinationname=clean_link(strtolower(basename($files["userfile$i"]['name'])),TRUE);
			if (strlen($destinationname)>MAX_FILENAME_SIZE)
				$destinationname=substr($destinationname,strlen($destinationname)-MAX_FILENAME_SIZE,MAX_FILENAME_SIZE);
			
			// build an alt-name for existing file name (Nfilename)
			if (file_exists(DATA_DIR_TREE.$path."/".$destinationname)||($section[$i]['IMG']==$destinationname)){			
				$o=0;
				while (file_exists(DATA_DIR_TREE.$path."/".$o.$destinationname)||($section[$i]['IMG']==$o.$destinationname)) $o++;
				$destinationname=$o.$destinationname;
			}
			
			if (!@move_uploaded_file($files["userfile$i"]['tmp_name'],DATA_DIR_TREE.$path."/".$destinationname)){
				$err_str=STR_ERR_SAVE;
 				$section[$i]['ERRCH']="*";
			}
			else{	
				@chmod(DATA_DIR_TREE.$path."/".$destinationname,0644);
				
				if (!create_thumb(DATA_DIR_TREE.$path."/".$destinationname,DATA_DIR_TREE.$path."/thumb.".$destinationname)){
					$section[$i]['ERRCH']="*";
				}else{
					if ($section[$i]['IMG']!=''){
						// delete old image and thumb
						@unlink(DATA_DIR_TREE.$path."/".$section[$i]['IMG']);
						@unlink(DATA_DIR_TREE.$path."/thumb.".$section[$i]['IMG']);
					}
					$section[$i]['IMG']=$destinationname;
				}
			}
		}
		$xml.= "\t<item img='".$section[$i]['IMG']."'";
		
		for ($j=0;$j<count($imgfield);$j++){
			$xml.= " ".strtolower($imgfield[$j]['field'])."='".$section[$i][$j]."'";
		}
		$xml.= ">\n";
		
		for ($j=0;$j<count($langs);$j++){
		
			$xml .= "\t\t<descr lang='".$langs[$j]."'>";;
			$xml .= "<![CDATA[";
			if (isset($section[$i]['TEXT'.strtoupper($langs[$j])])) $xml .= $section[$i]['TEXT'.strtoupper($langs[$j])];
			$xml .= "]]>";
			$xml .= "</descr>\n";
		}
		$xml.= "\t</item>\n";
		
	}
	$xml.= "</section>\n";
	
	if (USE_COVER_THUMB&&($section[$cover]['IMG']!='')){
		if (!create_thumb(DATA_DIR_TREE.$path."/".$section[$cover]['IMG'],DATA_DIR_TREE.$path."/index.jpg",COVER_THUMB_MAXW,COVER_THUMB_MAXH))
				$section[$i]['ERRCH']="*";
	}
	
	if ($fp=@fopen(DATA_DIR_TREE.$path.'/'.XML_SECT_PHOTO, 'w')){
		@fwrite ($fp,$xml);
		@fclose($fp);
	}else $err_str=STR_ERR_SAVE;
	
	delete_old_files($path);
	unlock(DATA_DIR_TREE);
}

// document lists management functions /////////////////////////////////////////

function cb_close_sectiondocs($parser, $tag) {

	global $sectiondocsindex,$langindex;
	
	if ($tag=="ITEM"){
		$sectiondocsindex=-1;
	}else if ($tag=="DESCR"){
		$langindex = -1;
	}
}

function cb_open_sectiondocs($parser, $tag, $attrs) {

	global $sectiondocs,$langs,$docfield,$sectiondocsindex,$langindex;
	
	if ($tag=="ITEM"){
		
		$sectiondocsindex=count($sectiondocs);
		
		$sectiondocs[$sectiondocsindex]['FILE']=$attrs['FILE'];
	
		for ($j=0;$j<count($docfield);$j++){
			$sectiondocs[$sectiondocsindex][$j]=clean_label($attrs[strtoupper($docfield[$j]['field'])]);
		}

	}else if ($tag=="DESCR"){
		
		$langindex=-1;
		for ($j=0;$j<count($langs);$j++){
			if (strtoupper($langs[$j])==strtoupper($attrs['LANG'])) $langindex=$j;
		}
	}
}

function cb_data_sectiondocs($parser, $data) {

	global $sectiondocs,$sectiondocsindex,$langindex,$langs;
	
	if (($langindex>=0)&&($sectiondocsindex>=0))
		$sectiondocs[$sectiondocsindex]['TEXT'.strtoupper($langs[$langindex])] .= $data;
}

function sectiondocs_load($path){

	global $sectiondocs,$sectiondocsindex,$langindex;
	
	$sectiondocs=array();
	$loaded=TRUE;
	$sectiondocsindex=-1;
	$langindex=-1;
	
	$parser = xml_parser_create(XML_ENCODING);
	xml_parser_set_option($parser,XML_OPTION_CASE_FOLDING,1);
	xml_parser_set_option($parser,XML_OPTION_SKIP_WHITE,1);
	xml_set_element_handler ( $parser, "cb_open_sectiondocs", "cb_close_sectiondocs" );
	xml_set_character_data_handler($parser, "cb_data_sectiondocs");
	if ($fp = @fopen(DATA_DIR_TREE.$path.'/'.XML_SECT_DOCS,'r')){
		while ($data = @fgets($fp, 8192))
			xml_parse($parser, $data, feof($fp));
		@fclose($fp);
	}
	else $loaded=FALSE;
	xml_parser_free($parser);
	
	return $loaded;
}

function sectiondocs_save($path,$files,$form_id,$sectiondocscount){

	global $sectiondocs,$err_str,$langs,$docfield;
	
	if ($sectiondocscount!=count($sectiondocs)){
		$err_str=STR_ERR_SAVE;
		return;
	}
	
	// verify lock file
	switch (verify_lock(DATA_DIR_TREE,$form_id)){
		case -1: $err_str= STR_ERR_SAVE;
			 return;
		case 0:  break;
		case 1:  return;
		case 2:  $err_str= STR_ERR_LOCK;
		         return;
	}
	
	$xml = "<?xml version='1.0' encoding='".XML_ENCODING."'?>\n";
	
	$xml.= "<sectiondocs>\n";
	
	for ($i=0;$i<count($sectiondocs);$i++){
		
		// load new files
		if ($files["userfile$i"]['name']!=''){
		
			if ($files["userfile$i"]['error']!=0){
				$err_str = STR_ERR_SAVE . " (err: ".$files["userfile$i"]['error'].")";
				$sectiondocs[$i]['ERRCH']="*";
			}
			
			$destinationname=clean_link(strtolower(basename($files["userfile$i"]['name'])),TRUE);
			if (strlen($destinationname)>MAX_FILENAME_SIZE)
				$destinationname=substr($destinationname,strlen($destinationname)-MAX_FILENAME_SIZE,MAX_FILENAME_SIZE);
			
			// build an alt-name for existing file name (Nfilename)
			if (file_exists(DATA_DIR_TREE.$path."/".$destinationname)||($sectiondocs[$i]['FILE']==$destinationname)){			
				$o=0;
				while (file_exists(DATA_DIR_TREE.$path."/".$o.$destinationname)||($sectiondocs[$i]['FILE']==$o.$destinationname)) $o++;
				$destinationname=$o.$destinationname;
			}
			
			if (!@move_uploaded_file($files["userfile$i"]['tmp_name'],DATA_DIR_TREE.$path."/".$destinationname)){
				$err_str=STR_ERR_SAVE;
 				$sectiondocs[$i]['ERRCH']="*";
			}
			else{
				@chmod(DATA_DIR_TREE.$path."/".$destinationname,0644);
				
				if ($sectiondocs[$i]['FILE']!=''){
					// delete old file
					@unlink(DATA_DIR_TREE.$path."/".$sectiondocs[$i]['FILE']);
				}
				$sectiondocs[$i]['FILE']=$destinationname;

			}
		}
		
		$xml.= "\t<item file='".$sectiondocs[$i]['FILE']."'";
		
		for ($j=0;$j<count($docfield);$j++){
			$xml.= " ".strtolower($docfield[$j]['field'])."='".$sectiondocs[$i][$j]."'";
		}
		$xml.= ">\n";
		
		for ($j=0;$j<count($langs);$j++){
		
			$xml .= "\t\t<descr lang='".$langs[$j]."'>";;
			$xml .= "<![CDATA[";
			if (isset($sectiondocs[$i]['TEXT'.strtoupper($langs[$j])])) $xml .= $sectiondocs[$i]['TEXT'.strtoupper($langs[$j])];
			$xml .= "]]>";
			$xml .= "</descr>\n";
		}
		$xml.= "\t</item>\n";
	}
	$xml.= "</sectiondocs>\n";
	
	if ($fp=@fopen(DATA_DIR_TREE.$path.'/'.XML_SECT_DOCS, 'w')){
		@fwrite ($fp,$xml);
		@fclose($fp);
	}else $err_str=STR_ERR_SAVE;
	
	delete_old_files($path);
	unlock(DATA_DIR_TREE);
}

// section texts lists management functions ////////////////////////////////////

function cb_close_sectiontext($parser, $tag) {

	global $descrindex;
	if ($tag=="DESCR") $descrindex=-1;

}

function cb_open_sectiontext($parser, $tag, $attrs) {

	global $descrindex,$langs;

	if ($tag=="DESCR"){
		for ($i=0;$i<count($langs);$i++){
			if ($langs[$i]==$attrs['LANG']) $descrindex=$i;
		}
	}
}

function cb_data_sectiontext($parser, $data) {

	global $descrindex,$descr;
	
	if ($descrindex!=-1)
		$descr[$descrindex].=$data;
}

function sectiontext_load($path){

	global $descrindex;

	$descr=array();
	$loaded=TRUE;
	$descrindex=-1;
	
	$parser = xml_parser_create(XML_ENCODING);
	xml_parser_set_option($parser,XML_OPTION_CASE_FOLDING,1);
	xml_parser_set_option($parser,XML_OPTION_SKIP_WHITE,1);
	xml_set_element_handler( $parser, "cb_open_sectiontext", "cb_close_sectiontext" );
	xml_set_character_data_handler($parser, "cb_data_sectiontext");
	if ($fp = @fopen(DATA_DIR_TREE.$path.'/'.XML_SECT_TEXT,'r')){
		while ($data = @fgets($fp, 8192))
			xml_parse($parser, $data, feof($fp));
		@fclose($fp);
	}
	else $loaded=FALSE;
	xml_parser_free($parser);
	
	return $loaded;
}

function sectiontext_save($path,$descr,$form_id){

	global $err_str,$langs;
	
	// verify lock file
	switch (verify_lock(DATA_DIR_TREE,$form_id)){
		case -1: $err_str= STR_ERR_SAVE;
			 return;
		case 0:  break;
		case 1:  return;
		case 2:  $err_str= STR_ERR_LOCK;
		         return;
	}
	
	$xml = "<?xml version='1.0' encoding='".XML_ENCODING."'?>\n";
	$xml.= "<sectiontext>\n";
	
	for ($i=0;$i<count($langs);$i++){
		
		$xml .= "\t<descr lang='".$langs[$i]."'>";;
		$xml .= "<![CDATA[";
		$xml .= $descr[$i];
		$xml .= "]]>";
		$xml .= "</descr>\n";
	}
	$xml.= "</sectiontext>\n";
	
	if ($fp=@fopen(DATA_DIR_TREE.$path.'/'.XML_SECT_TEXT, 'w')){
		@fwrite ($fp,$xml);
		@fclose($fp);
	}else $err_str=STR_ERR_SAVE;
	
	unlock(DATA_DIR_TREE);
}

// option management functions /////////////////////////////////////////////////

function cb_close_opt($parser, $tag) {

	global $optindex,$langindex;
	
	if ($tag=="ITEM"){
		$optindex=-1;
	}else if ($tag=="DESCR"){
		$langindex = -1;
	}
}

function cb_open_opt($parser, $tag, $attrs) {

	global $opt,$langs,$optfield,$optname,$optindex,$langindex;
	
	if ($tag=="ITEM"){
		
		$optindex=count($opt);
		
		for ($j=0;$j<count($optfield[$optname]);$j++){
			$opt[$optindex][$j]=clean_label($attrs[strtoupper($optfield[$optname][$j]['field'])]);
		}
			
		$opt[$optindex]['IMG']=$attrs['IMG'];
		$opt[$optindex]['FILE']=$attrs['FILE'];
		$opt[$optindex]['CODE']=$attrs['CODE'];
				
	}else if ($tag=="DESCR"){
		
		$langindex=-1;
		for ($j=0;$j<count($langs);$j++){
			if (strtoupper($langs[$j])==strtoupper($attrs['LANG'])) $langindex=$j;
		}
	}else $optname=$attrs['LABEL'];
}

function cb_data_opt($parser, $data) {

	global $opt,$optindex,$langindex,$langs;
	
	if (($langindex>=0)&&($optindex>=0))
		$opt[$optindex]['TEXT'.strtoupper($langs[$langindex])] .= $data;
}


function opt_load($optname){

	global $opt,$optindex,$langindex;
	
	$opt=Array();
	$optindex=-1;
	$langindex=-1;
	
	$parser = xml_parser_create(XML_ENCODING);
	xml_parser_set_option($parser,XML_OPTION_CASE_FOLDING,1);
	xml_parser_set_option($parser,XML_OPTION_SKIP_WHITE,1);
	xml_set_element_handler( $parser, "cb_open_opt", "cb_close_opt" ); 
	xml_set_character_data_handler($parser, "cb_data_opt");
	if ($fp = @fopen(DATA_DIR_OPT.strtolower($optname)."/".strtolower($optname).".xml",'r')){
		while ($data = @fgets($fp, 8192))
			xml_parse($parser, $data, feof($fp)); 
		@fclose($fp);
	}else{
		xml_parser_free($parser);
		return (touch_opt_folder(strtolower($optname)));
	}
	xml_parser_free($parser);
	
	return TRUE;
}

function opt_save($optname,$files,$todel,$form_id,$optcount){

	global $opt,$langs,$optfield,$err_str;
	
	if ($optcount!=count($opt)){
		$err_str=STR_ERR_SAVE;
		return;
	}
	
	// verify lock file
	switch (verify_lock(DATA_DIR_OPT,$form_id)){
		case -1: $err_str= STR_ERR_SAVE;
			 return;
		case 0:  break;
		case 1:  return;
		case 2:  $err_str= STR_ERR_LOCK;
		         return;
	}

	// create folder
	if (!file_exists(DATA_DIR_OPT.strtolower($optname))){
		if (!@mkdir(DATA_DIR_OPT.strtolower($optname))){
			$err_str= STR_ERR_SAVE;
			return;
		}
	}
				
	$xml = "<?xml version='1.0' encoding='".XML_ENCODING."'?>\n";
	$xml.= "<".strtolower($optname)." label='".$optname."'>\n";
	
	for ($i=0;$i<count($opt);$i++){	

		// load new files
		if ( isset($files["userfile$i"]['name']) && $files["userfile$i"]['name']!='' ){
		
			if ($files["userfile$i"]['error']!=0){
				$err_str = STR_ERR_SAVE . " (err: ".$files["userfile$i"]['error'].")";
				$opt[$i]['ERRCH']="*";
			}
			
			$destinationname=clean_link(strtolower(basename($files["userfile$i"]['name'])),TRUE);
			if (strlen($destinationname)>MAX_FILENAME_SIZE)
				$destinationname=substr($destinationname,strlen($destinationname)-MAX_FILENAME_SIZE,MAX_FILENAME_SIZE);
			
			// build an alt-name for existing file name (Nfilename)
			if (file_exists(DATA_DIR_OPT.strtolower($optname)."/".$destinationname)||($opt[$i]['IMG']==$destinationname)){
				$o=0;
				while (file_exists(DATA_DIR_OPT.strtolower($optname)."/".$o.$destinationname)||($opt[$i]['IMG']==$o.$destinationname)) $o++;
				$destinationname=$o.$destinationname;
			}
			
			if (!@move_uploaded_file($files["userfile$i"]['tmp_name'],DATA_DIR_OPT.strtolower($optname)."/".$destinationname)){
				$err_str=STR_ERR_SAVE;
 				$opt[$i]['ERRCH']="*";
			}
			else{	
				chmod(DATA_DIR_OPT.strtolower($optname)."/".$destinationname,0644);
				
				if (!create_thumb(DATA_DIR_OPT.strtolower($optname)."/".$destinationname,DATA_DIR_OPT.strtolower($optname)."/thumb.".$destinationname)){
					$opt[$i]['ERRCH']="*";
				}else{
					if ($opt[$i]['IMG']!=''){
						// delete old image and thumb
						@unlink(DATA_DIR_OPT.strtolower($optname)."/".$opt[$i]['IMG']);
						@unlink(DATA_DIR_OPT.strtolower($optname)."/thumb.".$opt[$i]['IMG']);
					}
					$opt[$i]['IMG']=$destinationname;
				}
			}
		}
	
		if (($todel[$i]=='on')&&($opt[$i]['FILE']!='')){
			@unlink(DATA_DIR_OPT.strtolower($optname)."/".$opt[$i]['FILE']);
			$opt[$i]['FILE']='';
		}
		
		if (isset($files["userfileb$i"]['name']) && $files["userfileb$i"]['name']!=''){
		
			if ($files["userfileb$i"]['error']!=0){
				$err_str = STR_ERR_SAVE . " (err: ".$files["userfileb$i"]['error'].")";
				$opt[$i]['ERRCH']="*";
			}
			
			$destinationname=clean_link(strtolower(basename($files["userfileb$i"]['name'])),TRUE);
			if (strlen($destinationname)>MAX_FILENAME_SIZE)
				$destinationname=substr($destinationname,strlen($destinationname)-MAX_FILENAME_SIZE,MAX_FILENAME_SIZE);
			
			// build an alt-name for existing file name (Nfilename)
			if (file_exists(DATA_DIR_OPT.strtolower($optname)."/".$destinationname)||(isset($opt[$i]['IMG']) && $opt[$i]['IMG']==$destinationname)){
				$o=0;
				while (file_exists(DATA_DIR_OPT.strtolower($optname)."/".$o.$destinationname)||($opt[$i]['IMG']==$o.$destinationname)) $o++;
				$destinationname=$o.$destinationname;
			}
			
			if (!@move_uploaded_file($files["userfileb$i"]['tmp_name'],DATA_DIR_OPT.strtolower($optname)."/".$destinationname)){
				$err_str=STR_ERR_SAVE;
 				$opt[$i]['ERRCH']="*";
			}
			else{	
				@chmod(DATA_DIR_OPT.strtolower($optname)."/".$destinationname,0644);
				
				if ($opt[$i]['FILE']!=''){
					// delete old file
					@unlink(DATA_DIR_OPT.strtolower($optname)."/".$opt[$i]['FILE']);
				}
				$opt[$i]['FILE']=$destinationname;
			}
		}
		
		$xml.= "\t<item img='".(isset($opt[$i]['IMG'])?$opt[$i]['IMG']:"")."' file='".(isset($opt[$i]['FILE'])?$opt[$i]['FILE']:"")."' code='".$opt[$i]['CODE']."'";
		
		for ($j=0;$j<count($optfield[$optname]);$j++){
			$xml.= " ".strtolower($optfield[$optname][$j]['field'])."='".$opt[$i][$j]."'";
		}

		$xml.= ">\n";
		
		for ($j=0;$j<count($langs);$j++){
		
			$xml .= "\t\t<descr lang='".$langs[$j]."'>";;
			$xml .= "<![CDATA[";
			if (isset($opt[$i]['TEXT'.strtoupper($langs[$j])])) $xml .= $opt[$i]['TEXT'.strtoupper($langs[$j])];
			$xml .= "]]>";
			$xml .= "</descr>\n";
		}
		$xml.= "\t</item>\n";
	}
		
	$xml.= "</".strtolower($optname).">\n";
	
	if ($fp=@fopen(DATA_DIR_OPT.strtolower($optname)."/".strtolower($optname).".xml",'w')){
		@fwrite ($fp,$xml);
		@fclose($fp);
	}else $err_str= STR_ERR_SAVE;
	
	// delete file not in list
	if ($dh = opendir(DATA_DIR_OPT.strtolower($optname))) {
		while (($file = readdir($dh)) !== false) {

			$todel=TRUE;
			if ($file==strtolower($optname).".xml") $todel=FALSE;
			foreach ($opt as $item){ 
				if ((isset($item['IMG']) && $item['IMG']==$file)||( isset($item['IMG']) && "thumb.".$item['IMG']==$file)){
					$todel=FALSE;
					break;
				}
				if (isset($item['FILE']) && $item['FILE']==$file){
					$todel=FALSE;
					break;
				}
			}
			if ($todel){
				@unlink(DATA_DIR_OPT.strtolower($optname)."/".$file);
				@unlink(DATA_DIR_OPT.strtolower($optname)."/thumb.".$file);
			}
		}
		closedir($dh);
	}
	
	if ((DELETE_WHEN_EMPTY==1)&&(count($opt)==0)){
		@unlink(DATA_DIR_OPT.strtolower($optname)."/".strtolower($optname).".xml");
		@rmdir(DATA_DIR_OPT.strtolower($optname));
	}

	unlock(DATA_DIR_OPT);
}

// fixed files functions /////////////////////////////////////////////////

function fix_save($files,$todel,$form_id){

	global $ffs,$err_str;

	if (!touch_fix_folder()) return FALSE;
	
	// verify lock file
	switch (verify_lock(DATA_DIR_FIX,$form_id)){
		case -1: $err_str= STR_ERR_SAVE;
			 return;
		case 0:  break;
		case 1:  return;
		case 2:  $err_str= STR_ERR_LOCK;
		         return;
	}
	
	for ($i=0;$i<count($ffs);$i++){
		
		if ($todel[$i]=='on') unlink(DATA_DIR_FIX.$ffs[$i]['path']);
	
		if ($files["userfile$i"]['name']!=''){
			if ($files["userfile$i"]['error']!=0){
				$err_str=STR_ERR_SAVE."(err: ".$files["userfile$i"]['error'].")";
				$ffs[$i]['ERRCH']="*";
				return;
			}
			if (!@move_uploaded_file($files["userfile$i"]['tmp_name'],DATA_DIR_FIX.$ffs[$i]['path'])){
				$err_str=STR_ERR_SAVE;
 				$ffs[$i]['ERRCH']="*";
 				return;
			}
			else chmod(DATA_DIR_FIX.$ffs[$i]['path'],0644);
		}
	}
	
	$xml = "<?xml version='1.0' encoding='".XML_ENCODING."'?>\n";
	$xml.= "<files>\n";
	
	$count=0;

	for ($i=0;$i<count($ffs);$i++)
		if (@stat(DATA_DIR_FIX.$ffs[$i]['path'])){
			$xml.= "\t<item path='".DATA_DIR_FIX.$ffs[$i]['path']."' />\n";
			$count++;
		}
	
	$xml.= "</files>\n";

	if ($fp=@fopen(DATA_DIR_FIX.XML_FXFILES, 'w')){
		@fwrite ($fp,$xml);
		@fclose($fp);
	}else $err_str = STR_ERR_SAVE;
	
	if ((DELETE_WHEN_EMPTY==1)&&($count==0)) @unlink(DATA_DIR_FIX.XML_FXFILES);

	unlock(DATA_DIR_FIX);
}

?>
