<?php
// (C)2006 Matteo Lucarelli
// sectiondocs editing code

require_once("load-save.php");

function validate($complete){

	global $err_str,$sectiondocs,$langs,$docfield;
	$err_str='';
	
	for ($i=0 ; $i<count($sectiondocs) ; $i++){
	
		// toglie spazi vuoti e caratteri speciali
		for ($j=0;$j<count($docfield);$j++){
			$sectiondocs[$i][$j]=clean_label($sectiondocs[$i][$j]);
		}		
	
		for ($j=0;$j<count($langs);$j++){
			if (isset($sectiondocs[$i]['TEXT'.strtoupper($langs[$j])])){
				if (USE_RICH_TEXT=="1") $sectiondocs[$i]['TEXT'.strtoupper($langs[$j])]=RTESafe($sectiondocs[$i]['TEXT'.strtoupper($langs[$j])]);
				else $sectiondocs[$i]['TEXT'.strtoupper($langs[$j])]=clean_label($sectiondocs[$i]['TEXT'.strtoupper($langs[$j])]);
			}
		}
	}
	
	if ($complete){
		for ($i=0 ; $i<count($sectiondocs) ; $i++){
		
			for ($j=0;$j<count($docfield);$j++){

				if (isset($docfield[$j]['required']) && $docfield[$j]['required']==1){
				
					// avoid empty required field
					if ($sectiondocs[$i][$j]==''){
						$err_str.= STR_ERR_FIELD." : ".$docfield[$j]['descr'];
						$sectiondocs[$i]['ERRCH']="*";
						return;

					}
					// avoid equal required fields
					for ($k=$i+1 ; $k<count($sectiondocs) ; $k++){
						if ($sectiondocs[$i][$j]==$sectiondocs[$k][$j]){
							$err_str.= STR_ERR_PATH." <b>".$sectiondocs[$k][$j]."</b>";
							$sectiondocs[$i]['ERRCH']="*";
							$sectiondocs[$k]['ERRCH']="*";
							return;			
						}
					}
				}
			}
		}
	}
}

$modified=TRUE;
$err_str='';

if (isset($_POST['sectiondocs'])) $sectiondocs=$_POST['sectiondocs'];

for ($i=0;$i<count($sectiondocs);$i++)
	for ($j=0;$j<count($langs);$j++)
		if (isset($_POST['rte'.$i.$j]))
			$sectiondocs[$i]['TEXT'.strtoupper($langs[$j])]=RTESafe($_POST['rte'.$i.$j]);

if (isset($_POST['sectiondocscount'])) $sectiondocscount=$_POST['sectiondocscount'];
if (isset($_POST['form_id'])) $form_id=$_POST['form_id'];

if (isset($_POST['sval']) && $_POST['sval']!='undefined') $_POST['cmd']=$_POST['sval']; // M$tupid-iE

if (isset($_POST['cmd'])){

	if ($_POST['cmd']=='revert'){
		sectiondocs_load($_GET['path']);
		$sectiondocscount=count($sectiondocs);
		$modified=FALSE;
	}
	
	if ($_POST['cmd']=='save'){
		validate(TRUE);
		if ($err_str==''){
			sectiondocs_save($_GET['path'],$_FILES,$form_id,$sectiondocscount);
			$modified=FALSE;
		}
	}
	
	if (substr($_POST['cmd'],0,3)=='add'){
		validate(FALSE);
		$toadd=substr($_POST['cmd'],3);
		for ($i=count($sectiondocs);$i>$toadd;$i--) $sectiondocs[$i]=$sectiondocs[$i-1];
		for ($i=0;$i<count($langs);$i++){
			for ($j=0;$j<count($docfield);$j++) $sectiondocs[$toadd][$j]="";
			$sectiondocs[$toadd]['TEXT'.strtoupper($langs[$i])]="";
		}
		$sectiondocs[$toadd]['FILE']="";
		$sectiondocscount++;
	}
	
	if (substr($_POST['cmd'],0,3)=='del'){
		validate(FALSE);
		$indextodel=substr($_POST['cmd'],3);
		for ($i=$indextodel;$i<count($sectiondocs);$i++) $sectiondocs[$i]=$sectiondocs[$i+1];
		unset($sectiondocs[count($sectiondocs)-1]);
		$sectiondocscount--;
	}
	
	if (substr($_POST['cmd'],0,3)=='mov'){
		validate(FALSE);
		$tomov=substr($_POST['cmd'],3);
		$tmpsec=$sectiondocs[$tomov];
		$sectiondocs[$tomov]=$sectiondocs[$tomov+1];
		$sectiondocs[$tomov+1]=$tmpsec;
	}

}else{
	if (!sectiondocs_load($_GET['path'])) $err_str=STR_ERR_PAGE;
	else{
		$sectiondocscount=count($sectiondocs);
		$modified=FALSE;
	}
}

if (USE_RICH_TEXT=="1")
	for ($i=0 ; $i<count($sectiondocs) ; $i++)
		for ($j=0;$j<count($langs);$j++)
			if (isset($sectiondocs[$i]['TEXT'.strtoupper($langs[$j])]))
				$sectiondocs[$i]['TEXT'.strtoupper($langs[$j])]=RTESafe($sectiondocs[$i]['TEXT'.strtoupper($langs[$j])]);

if (!$modified||!isset($form_id)) $form_id=$_SERVER['HTTP_HOST']."-".time();

print_header_with_menu(" ".STR_OF_SECTIONDOCS." ".$_GET['path'],"sectiondocs");
print_error($err_str);

if ($err_str!=STR_ERR_PAGE){

	if (USE_RICH_TEXT=="1") echo "<form method='post' enctype='multipart/form-data' action='index.php?page=sectiondocsedit.php&path=".$_GET['path']."' onSubmit='submitForm();'>\n";
	echo "<form method='post' enctype='multipart/form-data' action='index.php?page=sectiondocsedit.php&path=".$_GET['path']."'>\n";

	echo "<input type=hidden id='sval' name='sval' value='undefined'>\n"; // M$tupid-iE
	echo "<input type='hidden' name='MAX_FILE_SIZE' value='".return_bytes(ini_get("upload_max_filesize"))."'>\n";
	echo "<input type='hidden' name='form_id' value='".$form_id."'>\n";
	echo "<input type='hidden' name='sectiondocscount' value='".$sectiondocscount."'>\n";
	
	if (USE_RICH_TEXT=="1"){
		echo "<script language='JavaScript' type='text/javascript'>\n";
		echo "function submitForm() {\n";
		echo "	updateRTEs();\n";
		echo "	return true;\n";
		echo "}\n";
		echo "initRTE('jslib/images/', 'jslib/', '');\n";
		echo "</script>\n";
	}

	echo "<button type='submit' name='cmd' value='save' v='save' onClick='ssval(this.v)'>".STR_CMD_SAVE."</button>\n";
	echo "<button type='submit' name='cmd' value='add0' v='add0' onClick='ssval(this.v)'>".STR_ADD."</button>\n";
	
	if ($modified) echo "<button type='submit' name='cmd' value='revert' v='revert' onClick='ssval(this.v)'>".STR_CMD_REVERT."</button>\n";

	if (count($sectiondocs)!=0) {

		echo "<ol>\n";
		for($i=0 ; $i<count($sectiondocs); $i++){
		
			echo "<li>\n";
			
			echo "<span class='listnumber'>".($i+1)."</span>";
			if (isset($sectiondocs[$i]['ERRCH'])) echo "<span class='error'>".$sectiondocs[$i]['ERRCH']."</span>";
			
			echo "<table width=90%><tr>\n";
			echo "<td class=tdheader>";
			
			if ($i!=count($sectiondocs)-1) echo "<button type='submit' name='cmd' value='mov$i' v='mov$i' onClick='ssval(this.v)'>V</button>\n";
			echo "<button type='submit' name='cmd' value='del$i' v='del$i' onClick='ssval(this.v)'>X</button>\n";

			echo "</td></tr>\n";
			
			// fields non multilanguage
			echo "<tr><td>\n";			
			for ($j=0;$j<count($docfield);$j++){
				
				if ( isset($docfield[$j]["multilanguage"]) && $docfield[$j]["multilanguage"]!=1 )
					echo $docfield[$j]['descr'].": <input type='text' name='sectiondocs[$i][$j]' value='".$sectiondocs[$i][$j]."'>";
			}		
			echo "</td></tr>\n<tr>\n";
			
			echo "<td valign='bottom'>\n";
			
			if (USE_JS_TABS=="1") echo "<div class='tabber'>\n";
			else echo "<div>\n";
			
			for ($j=0;$j<count($langs);$j++) {

				if (USE_JS_TABS=="1") echo "<div class='tabbertab'>";
				else echo "<div>\n";
				
				if (USE_JS_TABS=="1") echo "<h2>".$langdescr[$j]."</h2>";
				
				// field multilanguage
				for ($l=0;$l<count($docfield);$l++){
					if ( isset($docfield[$l]["multilanguage"]) && $docfield[$l]["multilanguage"]==1 ){
						echo $docfield[$l+$j]['descr'].": <input type='text' name='sectiondocs[$i][".($l+$j)."]' value='".$sectiondocs[$i][$l+$j]."'><br>\n";
						$l += count($langs);
					}
				}
				
				if (USE_DOC_DESCR=="1"){
					if (USE_JS_TABS!="1") echo "<br>".STR_DESCR.(count($langs)==1?"":" (".$langs[$j].")");
					
					if (USE_RICH_TEXT=="1"){
						echo "<script language='JavaScript' type='text/javascript'>\n";
						echo "writeRichText('rte".$i.$j."', '".$sectiondocs[$i]['TEXT'.strtoupper($langs[$j])]."', '95%', '".THUMB_MAXH."px', true, false);\n";
						echo "</script>\n";
					}else{
						echo "<textarea class='itemdescr' name='sectiondocs[$i][TEXT".strtoupper($langs[$j])."]'>".$sectiondocs[$i]['TEXT'.strtoupper($langs[$j])]."</textarea>\n";
					}
				}
				
				echo "</div>";
			}
			
			echo "</div></td>";
			
			echo "</tr><tr><td>\n";	
			
			echo "<input type='hidden' name='sectiondocs[$i][FILE]' value='".$sectiondocs[$i]['FILE']."'>\n";	
			echo STR_NEWFILE.":<input type='file' name='userfile$i'>";
			
			echo "<span class='fileinfo'>";
			if ($sectiondocs[$i]['FILE']!=''){
				$statary=@stat(DATA_DIR_TREE.$_GET['path']."/".$sectiondocs[$i]['FILE']);
				echo format_stat_info($statary)."\n";
				echo "<a class='button' href='".DATA_DIR_TREE.$_GET['path']."/".$sectiondocs[$i]['FILE']."'>".STR_VIEW."</a>\n";
			}else echo format_stat_info("")."\n";
			echo "</span>";

			echo "</td></tr></table>\n";
		}
		echo "</ol>\n";
		echo "<button type='submit' name='cmd' value='save' v='save' onClick='ssval(this.v)'>".STR_CMD_SAVE."</button>\n";
		if ($modified) echo "<button type='submit' name='cmd' value='revert' v='revert' onClick='ssval(this.v)'>".STR_CMD_REVERT."</button>\n";
	}	
	echo "</form>";
}
?>


