<?php
// (C)2006 Matteo Lucarelli
// section editing code

require_once("load-save.php");

function validate($complete){

	global $err_str,$section,$langs,$imgfield;
	$err_str='';
	
	for ($i=0;$i<count($section);$i++){
	
		// toglie spazi vuoti e caratteri speciali
		for ($j=0;$j<count($imgfield);$j++){
			$section[$i][$j]=clean_label($section[$i][$j]);
		}	
	
		for ($j=0;$j<count($langs);$j++){
			if (isset($section[$i]['TEXT'.strtoupper($langs[$j])])){
				if (USE_RICH_TEXT=="1") $section[$i]['TEXT'.strtoupper($langs[$j])]=RTESafe($section[$i]['TEXT'.strtoupper($langs[$j])]);
				else $section[$i]['TEXT'.strtoupper($langs[$j])]=clean_label($section[$i]['TEXT'.strtoupper($langs[$j])]);
			}
		}
	}
	
	if ($complete){
		for ($i=0 ; $i<count($section) ; $i++){
		
			for ($j=0;$j<count($imgfield);$j++){

				if (isset($imgfield[$j]['required']) && $imgfield[$j]['required']==1){
				
					// avoid empty required field
					if ($section[$i][$j]==''){
						$err_str.= STR_ERR_FIELD." : ".$imgfield[$j]['descr'];
						$section[$i]['ERRCH']="*";
						return;
					}
					// avoid equal required fields
					for ($k=$i+1 ; $k<count($section) ; $k++){
						if ($section[$i][$j]==$section[$k][$j]){
							$err_str.= STR_ERR_PATH." <b>".$section[$k][$j]."</b>";
							$section[$i]['ERRCH']="*";
							$section[$k]['ERRCH']="*";
							return;			
						}
					}
				}
			}
		}
	}	
}

$modified=TRUE;
$err_str='';

if (isset($_POST['section'])) $section=$_POST['section'];

for ($i=0;$i<count($section);$i++)
	for ($j=0;$j<count($langs);$j++)
		if (isset($_POST['rte'.$i.$j]))
			$section[$i]['TEXT'.strtoupper($langs[$j])]=RTESafe($_POST['rte'.$i.$j]);

if (isset($_POST['sectioncount'])) $sectioncount=$_POST['sectioncount'];
if (isset($_POST['cover'])) $cover=$_POST['cover'];
if (isset($_POST['showcover'])) $showcover=$_POST['showcover'];
if (isset($_POST['form_id'])) $form_id=$_POST['form_id'];

if (isset($_POST['sval']) && $_POST['sval']!='undefined') $_POST['cmd']=$_POST['sval']; // M$tupid-iE

if (isset($_POST['cmd'])){

	if ($_POST['cmd']=='revert'){
		section_load($_GET['path']);		
		$sectioncount=count($section);
		$modified=FALSE;
	}
	
	if ($_POST['cmd']=='save'){
		validate(TRUE);
		if ($err_str==''){
			section_save($_GET['path'],$_FILES,$form_id,$sectioncount);
			$modified=FALSE;
		}
	}	
	
	if (substr($_POST['cmd'],0,3)=='add'){
		validate(FALSE);
		$toadd=substr($_POST['cmd'],3);
		for ($i=count($section);$i>$toadd;$i--) $section[$i]=$section[$i-1];
		for ($j=0;$j<count($langs);$j++){
			$section[$toadd]['TEXT'.strtoupper($langs[$j])]="";
		}
		for ($j=0;$j<count($imgfield);$j++){
			$section[$toadd][$j]="";
		}	

		$section[$toadd]['IMG']="";
		$sectioncount++;
	}
	
	if (substr($_POST['cmd'],0,3)=='del'){
		validate(FALSE);
		$todel=substr($_POST['cmd'],3);
		for ($i=$todel;$i<count($section);$i++) $section[$i]=$section[$i+1];
		unset($section[count($section)-1]);
		$sectioncount--;
	}
	
	if (substr($_POST['cmd'],0,3)=='mov'){
		validate(FALSE);
		$tomov=substr($_POST['cmd'],3);
		$tmpsec=$section[$tomov];
		$section[$tomov]=$section[$tomov+1];
		$section[$tomov+1]=$tmpsec;
	}

}else{
	if (!section_load($_GET['path'])) $err_str=STR_ERR_PAGE;
	else{
		$sectioncount=count($section);
		$modified=FALSE;
	}
}

if (USE_RICH_TEXT=="1")
	for ($i=0;$i<count($section);$i++)
		for ($j=0;$j<count($langs);$j++)
			if (isset($section[$i]['TEXT'.strtoupper($langs[$j])]))
				$section[$i]['TEXT'.strtoupper($langs[$j])]=RTESafe($section[$i]['TEXT'.strtoupper($langs[$j])]);

if (!$modified||!isset($form_id)) $form_id=$_SERVER['HTTP_HOST']."-".time();

print_header_with_menu(" ".STR_OF_SECTION." ".$_GET['path'],"section");
print_error($err_str);

if ($err_str!=STR_ERR_PAGE){

	if (USE_RICH_TEXT=="1") echo "<form method='post' enctype='multipart/form-data' action='index.php?page=sectionphotoedit.php&path=".$_GET['path']."' onSubmit='submitForm();'>\n";
	else echo "<form method='post' enctype='multipart/form-data' action='index.php?page=sectionphotoedit.php&path=".$_GET['path']."'>\n";
	
	echo "<input type=hidden id='sval' name='sval' value='undefined'>\n"; // M$tupid-iE
	echo "<input type='hidden' name='MAX_FILE_SIZE' value='".return_bytes(ini_get("upload_max_filesize"))."'>\n";
	echo "<input type='hidden' name='form_id' value='".$form_id."'>\n";
	echo "<input type='hidden' name='sectioncount' value='".$sectioncount."'>\n";
	
	if (USE_RICH_TEXT=="1"){
		echo "<script language='JavaScript' type='text/javascript'>\n";
		echo "function submitForm() {\n";
		echo "	updateRTEs();\n";
		echo "	return true;\n";
		echo "}\n";
		echo "initRTE('jslib/images/', 'jslib/', '');\n";
		echo "</script>\n";
	}

	echo "<button type='submit' name='cmd' value='save' v='save' onClick='ssval(this.v)'>".STR_CMD_SAVE."</button>\n";
	echo "<button type='submit' name='cmd' value='add0' v='add0' onClick='ssval(this.v)'>".STR_ADD."</button>\n";
	
	if ($modified) echo "<button type='submit' name='cmd' value='revert' v='revert' onClick='ssval(this.v)'>".STR_CMD_REVERT."</button>\n";
			
	if ((USE_COVER=="1")&&(USE_IMG_IMAGE=="1")){
		echo "<div class='formheader'>";
		echo "<input type='checkbox' class='radio' name='showcover' ".($showcover?"checked":"")." >".STR_SHOWCOVER."<br>\n";
		echo "</div>\n";
	}
	
	if (count($section)!=0) {

		echo "<ol>\n";
		for($i=0 ; $i<count($section); $i++){
		
			echo "<li>\n";
			
			echo "<span class='listnumber'>".($i+1)."</span>";
			if (isset($section[$i]['ERRCH'])) echo "<span class='error'>".$section[$i]['ERRCH']."</span>";
						
			echo "<table width=90%><tr>\n";
			
			if (USE_IMG_IMAGE=="1")	echo "<td class=tdheader colspan=2>";
			else echo "<td class=tdheader>";
						
			if ($i!=count($section)-1) echo "<button type='submit' name='cmd' value='mov$i' v='mov$i' onClick='ssval(this.v)'>V</button>\n";		
			echo "<button type='submit' name='cmd' value='del$i' v='del$i' onClick='ssval(this.v)'>X</button>\n";

			echo "</td></tr>\n<tr>\n";
			
			if (USE_IMG_IMAGE=="1"){
				echo "<td valign='bottom' align='left' width='". THUMB_MAXW ."' rowspan=2 >\n";
				echo "<input type='hidden' name='section[$i][IMG]' value='".$section[$i]['IMG']."'>\n";		
				if ($section[$i]['IMG']!=""){
					if (file_exists(DATA_DIR_TREE.$_GET['path']."/".$section[$i]['IMG']))
						echo "<a href='".DATA_DIR_TREE.$_GET['path']."/".$section[$i]['IMG']."' target='_blank'>\n";
					if (file_exists(DATA_DIR_TREE.$_GET['path']."/thumb.".$section[$i]['IMG']))
						echo "<img class='thumb' src='".DATA_DIR_TREE.$_GET['path']."/thumb.".$section[$i]['IMG']."'>\n";
					if (file_exists(DATA_DIR_TREE.$_GET['path']."/".$section[$i]['IMG'])) echo "</a>\n";
				}
				else echo "<img src='phplib/none.jpg'>\n";

				echo "</td>\n";
			}
			
			echo "<td>\n";
			
			for ($j=0;$j<count($imgfield);$j++){
				
				if ( isset($imgfield[$j]["multilanguage"]) && $imgfield[$j]["multilanguage"]!=1 )
								
					echo $imgfield[$j]['descr'].": <input type='text' name='section[$i][$j]' value='".$section[$i][$j]."'>";
			}		
			
			echo "</td></tr><tr>\n";
			
			echo "<td>";
			
			if (USE_JS_TABS=="1") echo "<div class='tabber'>";
			else echo "<div>";

			for ($j=0;$j<count($langs);$j++) {
			
				if (USE_JS_TABS=="1") echo "<div class='tabbertab'>";
				else echo "<div>";
				
				if (USE_JS_TABS=="1") echo "<h2>".$langdescr[$j]."</h2>";
				
				for ($l=0;$l<count($imgfield);$l++){
					if ( isset($imgfield[$l]["multilanguage"]) && $imgfield[$l]["multilanguage"]==1 ){
						echo $imgfield[$l+$j]['descr'].": <input type='text' name='section[$i][".($l+$j)."]' value='".$section[$i][$l+$j]."'><br>\n";
						$l += count($langs);
					}
				}
				
				if (USE_IMG_DESCR=="1"){
					if (USE_JS_TABS!="1") echo "<br>".STR_DESCR.(count($langs)==1?"":" (".$langs[$j].")").": <br>\n";
					
					if (USE_RICH_TEXT=="1"){
						echo "<script language='JavaScript' type='text/javascript'>\n";
						echo "writeRichText('rte".$i.$j."', '".$section[$i]['TEXT'.strtoupper($langs[$j])]."', '95%', '".THUMB_MAXH."px', true, false);\n";
						echo "</script>\n";
					}else{
						echo "<textarea class='itemdescr' name='section[$i][TEXT".strtoupper($langs[$j])."]'>".$section[$i]['TEXT'.strtoupper($langs[$j])]."</textarea>\n";
					}
					
				}else echo "<br>\n";			
				echo "</div>";
			}
			echo "</div></td>";
			

			echo "</tr>\n";
			
			if (USE_IMG_IMAGE=="1"){
			
				echo "<tr><td colspan=2>";
				echo " ".STR_NEWIMAGE.":<input type='file' name='userfile$i'>\n";
				if (USE_COVER=="1") {
					echo "<input type='radio' name='cover' class='radio' value='$i' ".($i==$cover?"checked":"").">".STR_USE_AS_COVER;
				}
				echo "</td></tr>";
			}
			
			echo "</table>\n";
		}
		echo "</ol>\n";
		echo "<button type='submit' name='cmd' value='save' v='save' onClick='ssval(this.v)'>".STR_CMD_SAVE."</button>\n";
		if ($modified) echo "<button type='submit' name='cmd' value='revert' v='revert' onClick='ssval(this.v)'>".STR_CMD_REVERT."</button>\n";
	}
	echo "</form>";
}
?>


