<?php
// (C)2006 Matteo Lucarelli
// tree editing section

require_once("load-save.php");

function validate($onlyclean=FALSE){

	global $err_str,$tree,$langs,$links;
	
	$err_str='';

	if (!$onlyclean){
	
		//echo "<pre>";
		//print_r($tree);
		//echo "</pre>";
	
	
		$links=build_links();

		
		for ($i=0 ; $i<count($tree) ; $i++){
			// avoid empty names
			if ($tree[$i]['LABEL'.strtoupper($langs[0])]==''){
				$err_str.= STR_ERR_FIELD;
				$tree[$i]['ERRCH']="*";
				break;
			}
			// avoid equal path
			for ($j=$i+1; $j<count($tree) ; $j++){
				if ($links[$i]==$links[$j]){
					$err_str.= STR_ERR_PATH." <b>".$links[$j]."</b>";
					$tree[$j]['ERRCH']="*";
					$tree[$i]['ERRCH']="*";
					break;
				}
			}
		}
	}
	
	for ($i=0 ; $i<count($tree) ; $i++){
		for ($j=0;$j<count($langs);$j++)
			$tree[$i]['LABEL'.strtoupper($langs[$j])]=clean_label($tree[$i]['LABEL'.strtoupper($langs[$j])]);
	}
	
	//echo "<pre>";
	//print_r($tree);
	//echo "</pre>";
}

$modified=TRUE;
$err_str='';

if (isset($_POST['tree'])) $tree=$_POST['tree'];
if (isset($_POST['treecount'])) $treecount=$_POST['treecount'];
if (isset($_POST['tomove'])) $tomove=$_POST['tomove'];
if (isset($_POST['sval']) && $_POST['sval']!='undefined') $_POST['cmd']=$_POST['sval']; // M$tupid-iE
if (isset($_POST['form_id'])) $form_id=$_POST['form_id'];

if (isset($_POST['cmd'])){

	if ($_POST['cmd']=='revert'){
		if (tree_load()){
			$treecount=count($tree);
			$modified=FALSE;
		}
	}
	
	if ($_POST['cmd']=='save'){
		validate();
		if ($err_str==''){
			if (($tomove[0]!="")&&($tomove[1]!="")){
				dirmv(ABS_PATH.DATA_DIR_TREE.$tomove[0],ABS_PATH.DATA_DIR_TREE.$tomove[1]);
				unset($tomove);
			}
			tree_save($form_id,$treecount);
			$modified=FALSE;
		}
	}	
	
	if (substr($_POST['cmd'],0,3)=='del'){
		validate(TRUE);
		$todel=substr($_POST['cmd'],3);
		for ($c=1;((($todel+$c)<count($tree))&&($tree[$todel+$c]['LEVEL']>$tree[$todel]['LEVEL']));$c++);
		for ($i=0;$i+$todel<count($tree);$i++) $tree[$todel+$i]=$tree[$todel+$i+$c];
		for (;$c>0;$c--){
			unset($tree[count($tree)-1]);
			$treecount--;
		}
	}
	
	if (substr($_POST['cmd'],0,3)=='add'){
		validate(TRUE);
		$toadd=substr($_POST['cmd'],3);
		for ($i=count($tree);$i>$toadd;$i--) $tree[$i]=$tree[$i-1];
		for ($j=0;$j<count($langs);$j++) $tree[$i]['LABEL'.strtoupper($langs[$j])]="";
		$tree[$toadd]['LINK']="";
		$tree[$toadd]['IMAGECOUNT']=0;
		$tree[$toadd]['DOCSCOUNT']=0;
		if (count($tree)>1) $tree[$toadd]['LEVEL']=$tree[$toadd+1]['LEVEL'];
		else $tree[$toadd]['LEVEL']=0;
		$treecount++;
	}
	
	if (substr($_POST['cmd'],0,3)=='sub'){
		validate(TRUE);
		$tosub=substr($_POST['cmd'],3);
		for ($i=count($tree);$i>$tosub+1;$i--) $tree[$i]=$tree[$i-1];
		for ($j=0;$j<count($langs);$j++) $tree[$i]['LABEL'.strtoupper($langs[$j])]="";
		$tree[$tosub+1]['LINK']="";
		$tree[$tosub+1]['LEVEL']=$tree[$tosub]['LEVEL']+1;
		$tree[$tosub+1]['IMAGECOUNT']=0;
		$tree[$tosub+1]['DOCSCOUNT']=0;
		$treecount++;
	}
	
	if (substr($_POST['cmd'],0,3)=='mov'){
		validate(TRUE);
		$tomov=substr($_POST['cmd'],3);
		$lmov=$tree[$tomov]['LEVEL'];
		$treedown[0]=$tree[$tomov];
		for ($c=1;($tomov+$c)<count($tree);$c++){
			if ($tree[$tomov+$c]['LEVEL']<=$lmov) break;
			$treedown[$c]=$tree[$tomov+$c];
		}
		$tree[$tomov]=$tree[$tomov+$c];
		for ($u=1;($tomov+$c+$u)<count($tree);$u++){
			if ($tree[$tomov+$c+$u]['LEVEL']<=$lmov) break;
			$tree[$tomov+$u]=$tree[$tomov+$c+$u];
		}
		for ($i=0;$i<$c;$i++) $tree[$tomov+$u+$i]=$treedown[$i];
	}
	
	if ((substr($_POST['cmd'],0,3)=='mto')&&(DONT_MOVE_TREE==0)){
		
		validate(TRUE);
		$valid=true;
		
		if (!isset($_POST['tomov'])) $valid=false;	
		$tomov=$_POST['tomov'];
		$movto=substr($_POST['cmd'],3);
		if ($movto==$tomov) $valid=false;
		
		// control for movto is not inside tomov
		if ($movto>$tomov){
			$valid=false;
			for ($i=$tomov+1;$i<=$movto;$i++)
				if ($tree[$i]['LEVEL']<=$tree[$tomov]['LEVEL'])
					$valid=true;
		}
		
		if ($valid){
		
			// save value for real directory move
			$tomove[0]=$tree[$tomov]['LINK'];
			$tomove[1]=$tree[$movto]['LINK'];

			// the tree part that will move
			$treetomov[0]=$tree[$tomov];
			$treetomov[0]['LEVEL']=$tree[$movto]['LEVEL']+1;		
			$c=1;
			while ($tree[$tomov+$c]['LEVEL']>$tree[$tomov]['LEVEL']){
				$treetomov[$c]=$tree[$tomov+$c];
				$treetomov[$c]['LEVEL']=$tree[$movto]['LEVEL']+$tree[$tomov+$c]['LEVEL']-$tree[$tomov]['LEVEL']+1;
				$c++;
			}
			
			// shift the tree
			if ($movto<$tomov){
				for ($i=$tomov+$c-1;$i>$movto;$i--) $tree[$i]=$tree[$i-$c];
				for ($i=0;$i<count($treetomov);$i++) $tree[$movto+1+$i]=$treetomov[$i];
			}else if ($movto>$tomov){
				for ($i=$tomov;$i<$movto;$i++) $tree[$i]=$tree[$i+$c];
				for ($i=0;$i<count($treetomov);$i++) $tree[$movto+1-$c+$i]=$treetomov[$i];
			}
		}else{
			$err_str=STR_ERR_MOVE;
			$modified=FALSE;
		}
		
	}
	
	if (substr($_POST['cmd'],0,3)=='mvo'){
	
		validate(TRUE);
		$valid=true;
		if (!isset($_POST['tomov'])) $valid=false;
		$tomov=$_POST['tomov'];
		if ($valid){
			
			// save value for real directory move
			$tomove[0]=$tree[$tomov]['LINK'];
			$tomove[1]='';
			
			// the tree part that will move
			$treetomov[0]=$tree[$tomov];
			$treetomov[0]['LEVEL']=0;		
			$c=1;
			while ($tree[$tomov+$c]['LEVEL']>$tree[$tomov]['LEVEL']){
				$treetomov[$c]=$tree[$tomov+$c];
				$treetomov[$c]['LEVEL']=$tree[$tomov+$c]['LEVEL']-$tree[$tomov]['LEVEL'];
				$c++;
			}
			
			// shift the tree
			for ($i=$tomov;$i<count($tree)-1;$i++) $tree[$i]=$tree[$i+$c];
			for ($i=0;$i<count($treetomov);$i++) $tree[count($tree)-$c+$i]=$treetomov[$i];			
	
		}else{
			$err_str=STR_ERR_MOVE;
			$modified=FALSE;
		}
	
	}
	
}else{
	if (tree_load()){
		$modified=FALSE;
		$treecount=count($tree);
		validate(TRUE);
	}
}

if (!$modified||!isset($form_id)) $form_id=$_SERVER['HTTP_HOST']."-".time();

print_header_with_menu("Menu","tree");
print_error($err_str);

echo "<form method='post' action='index.php'>\n";
echo "<input type=hidden id='sval' name='sval' value='undefined'>\n"; // M$tupid-iE
echo "<input type=hidden name='tomove[0]' value='".(isset($tomove)?$tomove[0]:"")."'>\n";
echo "<input type=hidden name='tomove[1]' value='".(isset($tomove)?$tomove[1]:"")."'>\n";
echo "<input type='hidden' name='form_id' value='".(isset($form_id)?$form_id:"")."'>\n";
echo "<input type='hidden' name='treecount' value='".(isset($treecount)?$treecount:0)."'>\n";

echo "<button type='submit' name='cmd' value='save' v='save' onClick='ssval(this.v)'>".STR_CMD_SAVE."</button>\n";
if (LOCK_UNTIL_LEVEL==0) echo "<button type='submit' name='cmd' value='add0' v='add0' onClick='ssval(this.v)'>".STR_CMD_ADDSECTION."</button>\n";
if ($modified) 
	echo "<button type='submit' name='cmd' value='revert' v='revert' onClick='ssval(this.v)'>".STR_CMD_REVERT."</button>\n";
	
if (count($tree)!=0) {

	echo "<ul>\n";
	$cl=0;
	for($i=0 ; $i<count($tree); $i++){
	
		$islast=TRUE;
		for ($j=$i+1;$j<count($tree);$j++){
			if ($tree[$j]['LEVEL']<$tree[$i]['LEVEL']) break;
			if ($tree[$j]['LEVEL']==$tree[$i]['LEVEL']){
				$islast=FALSE;
				break;
			}
		}
		for (;$tree[$i]['LEVEL']>$cl;$cl++) echo "<ul>\n";
		for (;$tree[$i]['LEVEL']<$cl;$cl--) echo "</ul>\n";
		
		echo "<li>\n";
		if (isset($tree[$i]['ERRCH'])) echo "<span class='error'>".$tree[$i]['ERRCH']."</span>";
			
		echo "<input type='hidden' name='tree[$i][LINK]' value='".$tree[$i]['LINK']."'>\n";
		echo "<input type='hidden' name='tree[$i][LEVEL]' value='".$tree[$i]['LEVEL']."'>\n";
		echo "<input type='hidden' name='tree[$i][IMAGECOUNT]' value='".$tree[$i]['IMAGECOUNT']."'>\n";
		echo "<input type='hidden' name='tree[$i][DOCSCOUNT]' value='".$tree[$i]['DOCSCOUNT']."'>\n";
	
		echo "<table>\n";
					
		echo"<tr>";

		for ($j=0;$j<count($langs);$j++) {
			echo "<td>\n";
			echo STR_NAME.(count($langs)==1?"":" (".$langdescr[$j].")");	
			echo "</td>\n";
		}
		
		echo"<td>\n";
		if ($tree[$i]['LEVEL']>=LIMIT_CONTENT_IMAGES) echo STR_CONTENT_IMAGES.":".$tree[$i]['IMAGECOUNT']." ";
		if ($tree[$i]['LEVEL']>=LIMIT_CONTENT_DOCS) echo STR_CONTENT_DOCS.":".$tree[$i]['DOCSCOUNT'];
		echo "</td>\n";
		
		echo"</tr>";
		
		echo"<tr>";
			
		for ($j=0;$j<count($langs);$j++) {
			echo "<td>\n";
			if ($tree[$i]['LEVEL']>=LOCK_UNTIL_LEVEL){
				echo "<input type='text' name='tree[$i][LABEL".strtoupper($langs[$j])."]' value='".$tree[$i]['LABEL'.strtoupper($langs[$j])]."'>\n";
			}else{
				echo "<span class='lockedlabel'>".$tree[$i]['LABEL'.strtoupper($langs[$j])]."</span>\n";
				echo "<input type='hidden' name='tree[$i][LABEL".strtoupper($langs[$j])."]' value='".$tree[$i]['LABEL'.strtoupper($langs[$j])]."'>\n";
			}
			echo "</td>\n";
		}	
		
		echo "<td>\n";
		
		if ($tree[$i]['LEVEL']>=LOCK_UNTIL_LEVEL) echo "<button type='submit' name='cmd' value='del$i' v='del$i' onClick='ssval(this.v)'>X</button>\n";
		if ((!$islast)&&($tree[$i]['LEVEL']>=LOCK_UNTIL_LEVEL)) echo "<button type='submit' name='cmd' value='mov$i' v='mov$i' onClick='ssval(this.v)'>V</button>\n";		

		if (($tree[$i]['LEVEL']<LIMIT_NEST)&&($tree[$i]['LEVEL']>=LOCK_UNTIL_LEVEL-1)){
			echo "<button type='submit' name='cmd' value='sub$i' v='sub$i' onClick='ssval(this.v)'>".STR_CMD_ADDSECTION."</button>\n";
		}

		if ((!$modified)&&($tree[$i]['LEVEL']>=LOCK_UNTIL_LEVEL)){
				if (($tree[$i]['LEVEL']>=LIMIT_CONTENT_IMAGES)&&(USE_SECTION_IMAGES=="1")) echo "<a class='button' href='index.php?page=sectionphotoedit.php&path=".$tree[$i]['LINK']."'>".STR_EDIT_IMG."</a>\n";
				if (($tree[$i]['LEVEL']>=LIMIT_CONTENT_DOCS)&&(USE_SECTION_DOCS=="1")) echo "<a class='button' href='index.php?page=sectiondocsedit.php&path=".$tree[$i]['LINK']."'>".STR_EDIT_DOCS."</a>\n";
				if (($tree[$i]['LEVEL']>=LIMIT_CONTENT_TEXT)&&(USE_SECTION_DESCR=="1")) echo "<a class='button' href='index.php?page=sectiontextedit.php&path=".$tree[$i]['LINK']."'>".STR_EDIT_TXT."</a>\n";
		}
		
		if ((!$modified)&&(DONT_MOVE_TREE==0)){
			if ($tree[$i]['LEVEL']>=LOCK_UNTIL_LEVEL) echo "<span class='actiongroup'>";
			if ($tree[$i]['LEVEL']<LIMIT_NEST)	
				echo "<button type='submit' name='cmd' value='mto$i' v='mto$i' onClick='ssval(this.v)'>".STR_CMD_MOVEHERE."</button>\n";
			if ($tree[$i]['LEVEL']>=LOCK_UNTIL_LEVEL){ 
				echo "<input type='radio' class='radio' name='tomov' value='$i'>";
				echo "</span>";
			}
		}
		
		echo "</td>";	
		echo "</tr>";
		
		echo"</table>\n";
		
	}
	for (;$cl>=0;$cl--) echo "</ul>\n";
	
	echo "<button type='submit' name='cmd' value='save' v='save' onClick='ssval(this.v)'>".STR_CMD_SAVE."</button>\n";
	
	if ((DONT_MOVE_TREE==0)&&(!$modified))
		echo "<button type='submit' name='cmd' value='mvo' v='mvo' onClick='ssval(this.v)'>".STR_CMD_MOVEHERE."</button>\n";
	
	if ($modified)  echo "<button type='submit' name='cmd' value='revert' v='revert' onClick='ssval(this.v)'>".STR_CMD_REVERT."</button>\n";
}
echo "</form>";

?>


