<?php
// (c)2006 Matteo Lucarelli
// utility, print and validation functions

function print_header_with_menu($curr_page,$help_type)
{
	global $optsection,$optsection_title,$lang;
	
	//if (USE_FADE_HELP==1) print_help($help_type,USE_FADE_HELP);
	
	echo "<h3>".CMS_TITLE." - 3editor CMS &copy;2006 <a href='http://www.matteolucarelli.net'>Matteo Lucarelli</a></h3>";
	
	if (USE_FADE_HELP==1){
		echo "<div id=\"fadehelp\">";
		print_help($help_type,USE_FADE_HELP);
		echo "</div>";
		
	}
	
	echo "<div class='nav'>";

	if ("Menu"!=$curr_page) echo "<a  class='button' href='index.php'>".STR_EDIT_MENU."</a>\n";
	else echo "<span class='inactivebutton'>".STR_EDIT_MENU."</span>\n";
	
	for ($i=0; $i<count($optsection); $i++){
		$label=htmlentities($optsection_title[$lang][$i],ENT_QUOTES);
		if ($optsection[$i]!=$curr_page) 
			echo "<a class='button' href='index.php?page=optedit.php&optname=".$optsection[$i]."'>".$label."</a>\n";
		else echo "<span class='inactivebutton'>".$label."</span>\n";
	}
	if (FX_FILES_SECTION!="0") 
		if (FX_FILES_SECTION!=$curr_page) 	
			echo "<a class='button' href='index.php?page=fixedit.php'>".FX_FILES_SECTION."</a>\n";
		else echo "<span class='inactivebutton'>".FX_FILES_SECTION."</span>\n";
		
	echo "</div>\n";
	echo "<h1>".STR_EDIT." $curr_page</h1>\n";
	
	if (USE_FADE_HELP==0) print_help($help_type,USE_FADE_HELP);
}

function print_error($err_str)
{
	if ($err_str) echo "<div class='error'>".STR_ERR." - ".$err_str."</div>\n";
}


function complete_multilanguage_fields()
{
	global $optsection,$optfield,$langs,$imgfield,$docfield;
	
	// optsections fields
	
	$tmp = array();
	
	for ($i=0;$i<count($optsection);$i++){
	
		$n=0;
		for ($j=0;$j<count($optfield[$optsection[$i]]);$j++){
	
			if ( isset($optfield[$optsection[$i]][$j]["multilanguage"]) && $optfield[$optsection[$i]][$j]["multilanguage"]==1){
			
				for ($l=0;$l<count($langs);$l++){
			
					if (USE_JS_TABS) $tmp[$optsection[$i]][$n]["descr"]=$optfield[$optsection[$i]][$j]["descr"];
					else $tmp[$optsection[$i]][$n]["descr"]=$optfield[$optsection[$i]][$j]["descr"]." (".$langs[$l].")";
					
					$tmp[$optsection[$i]][$n]["field"]=$optfield[$optsection[$i]][$j]["field"]."_".$langs[$l];
					$tmp[$optsection[$i]][$n]["required"]=$optfield[$optsection[$i]][$j]["required"];
					$tmp[$optsection[$i]][$n]["multilanguage"]=$optfield[$optsection[$i]][$j]["multilanguage"];
					$n++;
				}
			}else{
				$tmp[$optsection[$i]][$n]=$optfield[$optsection[$i]][$j];
				$n++;
			}
		}
	
	}
	$optfield=$tmp;
	
	// images fields
	
	$tmp = array();
	
	$n=0;
	for ($i=0;$i<count($imgfield);$i++){

		if ( isset($imgfield[$i]["multilanguage"]) && $imgfield[$i]["multilanguage"]==1){
		
			for ($l=0;$l<count($langs);$l++){
			
				if (USE_JS_TABS) $tmp[$n]["descr"]=$imgfield[$i]["descr"];
				else $tmp[$n]["descr"]=$imgfield[$i]["descr"]." (".$langs[$l].")";
				
				$tmp[$n]["field"]=$imgfield[$i]["field"]."_".$langs[$l];
				$tmp[$n]["required"]=$imgfield[$i]["required"];
				$tmp[$n]["multilanguage"]=$imgfield[$i]["multilanguage"];
				$n++;
			}
		}else{
			$tmp[$n]=$imgfield[$i];
			$n++;
		}
	}
	$imgfield=$tmp;
	
	// documents fields
	
	$tmp = array();
	
	$n=0;
	for ($i=0;$i<count($docfield);$i++){

		if ( isset($docfield[$i]["multilanguage"]) && $docfield[$i]["multilanguage"]==1){
		
			for ($l=0;$l<count($langs);$l++){
			
				if (USE_JS_TABS) $tmp[$n]["descr"]=$docfield[$i]["descr"];
				else $tmp[$n]["descr"]=$docfield[$i]["descr"]." (".$langs[$l].")";
				
				$tmp[$n]["field"]=$docfield[$i]["field"]."_".$langs[$l];
				$tmp[$n]["required"]=$docfield[$i]["required"];
				$tmp[$n]["multilanguage"]=$docfield[$i]["multilanguage"];
				$n++;
			}
		}else{
			$tmp[$n]=$docfield[$i];
			$n++;
		}
	}
	$docfield=$tmp;
	
}

// delete some XML/HTML cracking chars
function clean_label($str){

	$str = strtr($str, array("&" => "&amp;" , "'" => "&#039;" , ">" => "&gt;" , "<" => "&lt;" , chr(34) => "&quot;" , "\\" => "" ));
	return trim($str);
}

// delete all the links-cracking chars (for filenames and paths)
function clean_link($str){

	$str = strtr($str,"\xC0\xC1\xC2\xC3\xC4\xC5\xC6","AAAAAAA");
	$str = strtr($str,"\xC7","C");
	$str = strtr($str,"\xC8\xC9\xCA\xCB","EEEE");
	$str = strtr($str,"\xCC\xCD\xCE\xCF","IIII");
	$str = strtr($str,"\xD1","N");
	$str = strtr($str,"\xD2\xD3\xD4\xD5\xD6\xD8","OOOOOO");
	$str = strtr($str,"\xDD","Y");
	$str = strtr($str,"\xDF","S");
	$str = strtr($str,"\xE0\xE1\xE2\xE3\xE4\xE5\xE6","aaaaaaa");
	$str = strtr($str,"\xE7","c");
	$str = strtr($str,"\xE8\xE9\xEA\xEB","eeee");
	$str = strtr($str,"\xEC\xED\xEE\xEF","iiii");
	$str = strtr($str,"\xF1","n");
	$str = strtr($str,"\xF2\xF3\xF4\xF5\xF6\xF8","oooooo");
	$str = strtr($str,"\xF9\xFA\xFB\xFC","uuuu");
	$str = strtr($str,"\xFD\xFF","yy");
	
	$str=strtolower($str);
	$str = strtr($str, array("&"  => "e", 
	                         "'"  => "_",  
	                         "/"  => "_", 
	                         "\\" => "_",  
	                         ":"  => "_", 
	                         "*"  => "_",
	                         "?"  => "_", 
	                         "\"" => "_",
	                         "<"  => "_", 
	                         ">"  => "_",
	                         "|"  => "_", 
	                         " "  => "_",
	                         "#"  => "_")
	            );
	            
	for ($i=0;$i<strlen($str);$i++) 
		if (strchr(".0123456789abcdefghijklmnopqrstuvwxyz",$str{$i})==FALSE) $str{$i}='_';
	            
	return $str;
}

function RTESafe($strText) {

	$tmpString = trim($strText);
   	
   	//if ($tmpString == "") {
      	//	$tmpString = "<br>\n";
      	//}

	//convert all types of single quotes
	$tmpString = str_replace(chr(145), chr(39), $tmpString);
	$tmpString = str_replace(chr(146), chr(39), $tmpString);
	$tmpString = str_replace("'", "&#39;", $tmpString);

	//convert all types of double quotes
	$tmpString = str_replace(chr(147), chr(34), $tmpString);
	$tmpString = str_replace(chr(148), chr(34), $tmpString);

	//replace carriage returns & line feeds
	$tmpString = str_replace(chr(10), " ", $tmpString);
	$tmpString = str_replace(chr(13), " ", $tmpString);

	return $tmpString;
}

// convert in bytes the PHP notation K|M|G
function return_bytes($val) {

	$val = trim($val);
	$last = strtolower($val{strlen($val)-1});
	switch($last) {
		// The 'G' modifier is available since PHP 5.1.0
		case 'g':
		        $val *= 1024;
		case 'm':
		        $val *= 1024;
		case 'k':
		        $val *= 1024;
	}
	return $val;
}

// convert the PHP notation K|M|G in bytes 
function return_notation_bytes($val,$decimaldig) {

	if ($val>1073741824) return number_format(($val/1073741824),$decimaldig)."G";
	else if ($val>1048576) return number_format(($val/1048576),$decimaldig)."M";
	else if ($val>1024) return number_format(($val/1024),$decimaldig)."K";	
	return number_format($val,$decimaldig);
}

// build arry of sections paths
function build_links()
{
	global $tree,$langs;

	$cl=0;
	$links=Array();
	
	for ($i=0;$i<count($tree);$i++){
		
		if ($tree[$i]['LEVEL']==0) $path=clean_link($tree[$i]['LABEL'.strtoupper($langs[0])]);
		else if ($tree[$i]['LEVEL']>$cl) $path .= "/".clean_link($tree[$i]['LABEL'.strtoupper($langs[0])]);
		else{
			for (;$tree[$i]['LEVEL']<=$cl;$cl--) $path = dirname($path);
			$path .= "/".clean_link($tree[$i]['LABEL'.strtoupper($langs[0])]);
		}
		$cl=$tree[$i]['LEVEL'];
		$links[$i]=$path;
	}
	
	return $links;
}

// thumbnails generator
// THUMB_GEN: I=imagemagik | L=libgd
function create_thumb($imagefile, $thumbfile, $maxw=THUMB_MAXW, $maxh=THUMB_MAXH) {

	global $err_str;

	if (THUMB_GEN=="I") {
	
		if (THUMB_MODE=="R"){
			system("\"".IMGMGK_PATH."convert\" -geometry ".$maxw."x".$maxh." \"$imagefile\" \"$thumbfile\"",$ret);
		}else{
			$imageinfo=getimagesize($imagefile);
			$x=(int)($imageinfo[0]/2-$maxw/2);
			$y=(int)($imageinfo[1]/2-$maxh/2);
			system("\"".IMGMGK_PATH."convert\" -crop ".$maxw."x".$maxh."+".$x."+".$y." \"$imagefile\" \"$thumbfile\"",$ret);
			echo "\"".IMGMGK_PATH."convert\" -crop ".$maxw."x".$maxh."+".$x."+".$y." \"$imagefile\" \"$thumbfile\"";
		}
		if ($ret!=0){		
			$err_str = STR_ERR_THUMB;
			return FALSE;
		}
		return true;
	} else if (THUMB_GEN=="L") {
	
		// need libgd support in PHP - gif jpg and png are supported
		$imageinfo=getimagesize($imagefile);
		if (!$imageinfo) return FALSE;
		
		
		if ( (intval($imageinfo[0])*intval($imageinfo[1])*4) > (intval(ini_get("memory_limit"))*1000000) ){
			$err_str= STR_ERR_SAVE." (php memory_limit=".ini_get("memory_limit").")";
			return FALSE;
		}
	
		switch ($imageinfo[2]) {
			case 1:
				$imagecreator = "imagecreatefromgif";
				break;
			case 2:
				$imagecreator = "imagecreatefromjpeg";
				break;
			case 3:
				$imagecreator = "imagecreatefrompng";
				break;
			default:
				$err_str= STR_ERR_THUMB;
				return FALSE;
		}
		if (!function_exists($imagecreator)){
				$err_str = STR_ERR_THUMB;
				return FALSE;		
		}
		
		$src_img=$imagecreator($imagefile);
		
		if (THUMB_MODE=="R"){
			$thumbw = min( $maxw, (int) ( $imageinfo[0] / $imageinfo[1] * $maxh + 0.5));
			$thumbh = min( $maxh, (int) ( $imageinfo[1] / $imageinfo[0] * $maxw + 0.5));
			$dst_img = imagecreatetruecolor($thumbw, $thumbh);
			imagecopyresized($dst_img, $src_img, 0, 0, 0, 0, $thumbw, $thumbh, $imageinfo[0], $imageinfo[1]);
		}else{
			$dst_img = imagecreatetruecolor($maxw, $maxh);
			imagecopy($dst_img, $src_img, 0, 0, (int)(($imageinfo[0]+$maxw)/2), (int)(($imageinfo[1]+$maxh)/2), $maxw, $maxh);
		}
		
		$ext=strtolower(strchr($imagefile,"."));
		if ($ext=="gif") imagegif($dst_img, $thumbfile);
		else if (($ext=="jpg")||("jpeg")) imagejpeg($dst_img, $thumbfile);
		else if ($ext=="png") imagepng($dst_img, $thumbfile);
		imagedestroy($dst_img);
		return TRUE;
	}
	$err_str = STR_ERR_THUMB;
	return FALSE;
}

// (C) bobbfwed at comcast dot net
// move a directory and all subdirectories and files (recursive)
// void dirmv( str 'source directory', str 'destination directory' [, bool 'overwrite existing files' [, str 'location within the directory (for recurse)']] )
function dirmv($source, $dest, $overwrite = false, $funcloc = NULL){

	if(is_null($funcloc)){
		$dest .= '/' . strrev(substr(strrev($source), 0, strpos(strrev($source), '/')));
		$funcloc = '/';
	}

	if(!is_dir($dest . $funcloc))
		@mkdir($dest . $funcloc); // make subdirectory before subdirectory is copied

	if($handle = opendir($source . $funcloc)){ // if the folder exploration is sucsessful, continue
		while(false !== ($file = readdir($handle))){ // as long as storing the next file to $file is successful, continue
			if($file != '.' && $file != '..'){
				$path  = $source . $funcloc . $file;
				$path2 = $dest . $funcloc . $file;

				if(is_file($path)){
					if(!is_file($path2)){
						if(!@rename($path, $path2)){
							echo '<font color="red">File ('.$path.') could not be moved, likely a permissions problem.</font>';
						}
					} elseif($overwrite){
						if(!@unlink($path2)){
							echo 'Unable to overwrite file ("'.$path2.'"), likely to be a permissions problem.';
					} else
						if(!@rename($path, $path2)){
							echo '<font color="red">File ('.$path.') could not be moved while overwritting, likely a permissions problem.</font>';
						}
					}
				} elseif(is_dir($path)){
					dirmv($source, $dest, $overwrite, $funcloc . $file . '/'); //recurse!
					rmdir($path);
				}
			}
		}
		closedir($handle);
	}
}

// generate new numeric code higher than all $array[0..n]['CODE']
function new_code($array)
{
	$higher=0;
	foreach ($array as $item){
		if (isset($item['CODE']) && $item['CODE']>$higher) $higher=$item['CODE'];
	}
	return ($higher+1);
}


// lock a path for secure saving
// return -1: ERROR
//         0: ok, lock created
//         1: lock exists with the same id
//         2: lock exists with a different id
function verify_lock($path,$id)
{
	$fp=@fopen($path."/lock","r");
	if ($fp){
		$fid=@fread($fp,filesize($path."/lock"));
		if ($fid==$id) $ret=1;
		else $ret=2;
		
		@fclose($fp);
		return $ret;
	}
	
	$fp=@fopen($path."/lock","w");
	if ($fp){
		@fwrite($fp,$id);
		@fclose($fp);
		return 0;
	}
	return -1;
}

// unlock path
function unlock($path){
	@unlink($path."/lock");
}

// create data folders
function touch_tree_folder()
{
	global $err_str;
	
	if (!file_exists(DATA_DIR_TREE)) @mkdir(DATA_DIR_TREE,0777);
	
	if (!file_exists(DATA_DIR_TREE)){
		$err_str = STR_ERR_SAVE." (".DATA_DIR_TREE.")" ;
		return FALSE;
	}
		
	if ($fp=@fopen(DATA_DIR_TREE.XML_TREE,'w')){
		@fwrite($fp,"<?xml version='1.0' encoding='".XML_ENCODING."'?>\n");
		@fclose($fp);
	}
	
	if (!file_exists(DATA_DIR_TREE.XML_TREE)){
		$err_str = STR_ERR_SAVE." (".DATA_DIR_TREE.XML_TREE.")" ;
		return FALSE;
	}
	
	return TRUE;
}

function touch_opt_folder($optname)
{
	global $err_str;
	
	if (!file_exists(DATA_DIR_OPT)) @mkdir(DATA_DIR_OPT,0777);
	
	if (!file_exists(DATA_DIR_OPT)){
		$err_str = STR_ERR_SAVE." (".DATA_DIR_OPT.")";
		return FALSE;
	}

	if (!file_exists(DATA_DIR_OPT.$optname)) @mkdir(DATA_DIR_OPT.$optname,0777);
	
	if (!file_exists(DATA_DIR_OPT.$optname)){
		$err_str = STR_ERR_SAVE." (".DATA_DIR_OPT.$optname.")";
		return FALSE;
	}

	if ($fp = @fopen(DATA_DIR_OPT.$optname."/".$optname.".xml",'w')){
		@fwrite($fp,"<?xml version='1.0' encoding='".XML_ENCODING."'?>\n");
		@fclose($fp);
	}
	
	if (!file_exists(DATA_DIR_OPT.$optname."/".$optname.".xml")){
		$err_str = STR_ERR_SAVE." (".DATA_DIR_OPT.$optname."/".$optname.".xml)";
		return FALSE;
	}
}

function touch_fix_folder()
{
	global $err_str;
	
	if (!file_exists(DATA_DIR_FIX)) @mkdir(DATA_DIR_FIX,0777);
	
	if (!file_exists(DATA_DIR_FIX)){
		$err_str = STR_ERR_SAVE." (".DATA_DIR_FIX.")";
		return FALSE;
	}
	return TRUE;
}

?>
